<?php

namespace Picea\Ui\Form;

use Picea\Ui\Common\UiElement;
use Picea\Extension\Extension;
use Picea\Extension\ExtensionTrait;

class UiInput extends UiElement implements Extension {
    use ExtensionTrait;

    public string $token = "ui.input";

    public string $tag = "input";

    public array $attributes = [
       'class' => 'ui-input',
    ];

    public function parse(/*\Picae\Compiler\Context*/ &$context, ?string $arguments, string $token) : string
    {
        list($name, $value, $options) = array_pad(explode(',', $arguments), 3, null);

        $this->attributes['name'] = $this->trim($name);
        $this->setValue($this->trim($value));
        $this->attributes($this->parseOptions($options));
        return $this->render();
    }


    protected function setValue($value) : void
    {
        $this->attributes['value'] = $value;
    }

}
